/* Copyright 1996-1999, CLRC Daresbury Laboratory.
   For licence conditions, see the file COPYING in the distribution.
 */

#ifndef __XDL_VIEW_EXT_H__
#define __XDL_VIEW_EXT_H__

/* External definitions for XDL view-object routines */
/* ================================================= */

/* xdl-view routines include files */
#include "xdl_view.h"

/* Global data XDL view-object handling  routines */
/* ============================================== */

/* The following items are set/initialised by a call to xdl_open_view */

extern Display      *XDL_display;          /*Display for use with Xdl routines*/
extern XtAppContext XDL_app;               /*Application context*/
extern int          XDL_screen;            /*Screen no.*/
extern int          XDL_open;              /*XDL_VIEW opened flag*/
extern int          XDL_num_view_objects;  /*Number of view-objects set up*/
extern int          XDL_max_alloc_objects; /*Max no. of view-objects for which
                                             table space has been allocated*/
extern XDl_view_object **XDL_view_objects; /*Array of pointers to 
                                             XDL_view_object structures*/


extern XFontStruct  *XDL_fontinfo;         /*Standard (12) font*/
extern XFontStruct  *XDL_fontinfo_bold;    /*Standard (12) bold font*/
extern XFontStruct  *XDL_fonts[5];  /* fonts very small, small,
                                             medium, large and very large*/
extern XFontStruct  *XDL_bold_fonts[5]; /* bold fonts very small,
                                                 small, medium, large and very 
                                                 large */
extern Cursor       XDL_default_cursor;    /*Default cursor for view_objects*/

extern int          XDL_color;               /*Colour availability flag
                                               = 0, not available - monochrome
                                               = 1, grays
                                               = 2, colour*/
extern int          XDL_display_type;        /*Display type to be used 
                                               = StaticGray, GrayScale,
                                                 StaticColor, PseudoColor,
                                                 TrueColor or DirectColor
                                                 (Values defined in X.h)*/
extern int          XDL_csets_alloc;        /* =1 requested colour sets 
                                                  allocated with writeable 
                                                  colour cells
                                               =0 requested colour sets not
                                                  allocated (static display type
                                                  or less than 8 bit planes)*/
extern int          XDL_display_cells;       /*No. of color cells available*/
extern Visual       *XDL_visual;             /*Visual for creating windows*/
extern int          XDL_pw_depth;            /*Depth for paint windows*/
extern int          XDL_image_depth; /* depth of selected image type */
extern int          XDL_image_bits; /* bits per pixel of selected image type */
extern Colormap     XDL_colormap;      /*Colormap selected for the application*/
extern int          XDL_num_colorsets; /*Number of colormap sets (in addition to
                                         the standard short pallette)*/
extern XDl_colorset XDL_colorsets[MAXCOLORSETS];
                                            /*Array of allocated colormap sets*/
extern unsigned long  XDL_blackpixel;        /*Black pixel no.*/
extern unsigned long  XDL_whitepixel;        /*White pixel no.*/
extern unsigned long  XDL_redpixel;          /*Red pixel no.*/
extern unsigned long  XDL_yellowpixel;       /*Yellow pixel no.*/
extern unsigned long  XDL_greenpixel;        /*Green pixel no.*/
extern unsigned long  XDL_cyanpixel;         /*Cyan pixel no.*/
extern unsigned long  XDL_bluepixel;         /*Blue pixel no.*/
extern unsigned long  XDL_magentapixel;      /*Magenta pixel no.*/

extern GC XDL_active_strip_gc;   /*GC for standard 'view-object active for
                                   input to the application' window use*/

extern int XDL_return_data_vh;   /*Data returned from 'active' view-object
                                   flag = 0, none returned
                                        > 0, the view-object handle of the
                                             view-object returning the data*/
extern Atom XDL_paste_buffer;    /*Atom for xdl_view cut/paste string buffers */
extern int XDL_tmr_events;       /*Timer events handling in progress flag
                                   =0 no, =1 yes */

extern char * XDL_pointers[MAXPOINTERS];  /* List of string pointers */
extern int    XDL_pointers_index;         /* Last index to pointers currently 
                                             used (list used in a circular 
                                             manner) */

#endif /* ! __XDL_VIEW_EXT_H__ */
